#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <commctrl.h>
#include "resource.h"

#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"version.lib")

bool	fMajor = true;
bool	fMinor = true;
bool	fsp = true;


LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);


int WINAPI _tWinMain(HINSTANCE hCurInst, HINSTANCE hPrevInst, LPTSTR lpsCmdLine, int nCmdShow){
	//	_CAO{bNX̕\
	DialogBox(hCurInst, TEXT("DLG1"), 0, (DLGPROC)DlgProc);
//	IsWindowsServer();
	return (int)0;
}

BOOL IsWindowsVersionChk(DWORD Major, DWORD Minor, WORD sp,BYTE cond){
	OSVERSIONINFOEX os;
	DWORDLONG	dwlConditionMask = 0;
	ZeroMemory(&os, sizeof(os));
	os.dwOSVersionInfoSize = sizeof(os);
	if (fMajor==true)
		dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_MAJORVERSION, cond);
	if (fMinor==true)
		dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_MINORVERSION, cond);
	if (fsp==true)
		dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_SERVICEPACKMAJOR, cond);
	os.dwMajorVersion = Major;
	os.dwMinorVersion = Minor;
	os.wServicePackMajor = sp;
	return VerifyVersionInfo(&os, ((fMajor == true) ? VER_MAJORVERSION : 0) | ((fMinor == true) ? VER_MINORVERSION : 0) | ((fsp == true) ? VER_SERVICEPACKMAJOR: 0), dwlConditionMask);
}

TCHAR editBuf[32768];

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR buf[1024];
	static HWND hCombobox;
	static HWND hMajor;
	static HWND hMinor;
	static HWND hsp;
	static DWORD Major;
	static DWORD Minor;
	static WORD sp;
	static BYTE cond=1;
	static HWND hSrc;

	switch (msg) {
	case WM_INITDIALOG:{
		hCombobox = GetDlgItem(hDlg, IDC_COMBOBOX111);
		SendMessage(hCombobox, CB_INSERTSTRING, 0, (LPARAM)_TEXT("VER_EQUAL"));
		SendMessage(hCombobox, CB_INSERTSTRING, 1, (LPARAM)_TEXT("VER_GREATER"));
		SendMessage(hCombobox, CB_INSERTSTRING, 2, (LPARAM)_TEXT("VER_GREATER_EQUAL"));
		SendMessage(hCombobox, CB_INSERTSTRING, 3, (LPARAM)_TEXT("VER_LESS"));
		SendMessage(hCombobox, CB_INSERTSTRING, 4, (LPARAM)_TEXT("VER_LESS_EQUAL"));
		SendMessage(hCombobox, CB_SETCURSEL, cond-1, 0);
		hMajor = GetDlgItem(hDlg, IDC_EDIT100);
		hMinor = GetDlgItem(hDlg, IDC_EDIT102);
		hsp = GetDlgItem(hDlg, IDC_EDIT103);
		SetWindowText(hMajor, _TEXT("6"));
		SetWindowText(hMinor, _TEXT("1"));
		SetWindowText(hsp, _TEXT("0"));
		hSrc = GetDlgItem(hDlg, IDC_EDITBOX112);
		SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX200),BM_SETCHECK,BST_CHECKED,0);
		SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX202),BM_SETCHECK,BST_CHECKED,0);
		SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX203),BM_SETCHECK,BST_CHECKED,0);
		return TRUE;
	}
	case WM_COMMAND:
		switch (wParam){
		case IDC_EDIT100 | (EN_CHANGE << 16) :	//	GfBbg{bNXύXꂽꍇ
			GetWindowText(hMajor, buf, sizeof(buf) / sizeof(TCHAR));
			Major = _ttoi(buf);
			return FALSE;
		case IDC_EDIT102 | (EN_CHANGE << 16) :	//	GfBbg{bNXύXꂽꍇ
			GetWindowText(hMinor, buf, sizeof(buf) / sizeof(TCHAR));
			Minor = _ttoi(buf);
			return FALSE;
		case IDC_EDIT103 | (EN_CHANGE << 16) :	//	GfBbg{bNXύXꂽꍇ
			GetWindowText(hsp, buf, sizeof(buf) / sizeof(TCHAR));
			sp = _ttoi(buf);
			return FALSE;
		case IDC_COMBOBOX111 | (CBN_SELCHANGE << 16) :
			cond = (BYTE)SendMessage(hCombobox, CB_GETCURSEL, 0, 0) + 1;
			return FALSE;
		case IDC_CHECKBOX200 | (BN_CLICKED<<16):
			if(SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX200),BM_GETCHECK,BST_CHECKED,0)==BST_UNCHECKED){
				EnableWindow(hMajor,FALSE);
				fMajor = false;
			}
			else{
				EnableWindow(hMajor, TRUE);
				fMajor = true;
			}
			return FALSE;
		case IDC_CHECKBOX202 | (BN_CLICKED<<16):
			if(SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX202),BM_GETCHECK,BST_CHECKED,0)==BST_UNCHECKED){
				EnableWindow(hMinor,FALSE);
				fMinor = false;
			}else{
				EnableWindow(hMinor, TRUE);
				fMinor = true;
			}
			return FALSE;
		case IDC_CHECKBOX203 | (BN_CLICKED<<16):
			if(SendMessage(GetDlgItem(hDlg,IDC_CHECKBOX203),BM_GETCHECK,BST_CHECKED,0)==BST_UNCHECKED){
				EnableWindow(hsp,FALSE);
				fsp = false;
			}else{
				EnableWindow(hsp, TRUE);
				fsp = true;
			}
			return FALSE;
		default:
			switch (LOWORD(wParam)) {
			case IDOK:{
						  TCHAR conds[32];
						  HWND hRet = GetDlgItem(hDlg, IDC_EDIT115);
						  SendMessage(hCombobox, WM_GETTEXT, sizeof(conds) / sizeof(TCHAR), (LPARAM)conds);
						  _stprintf_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT("IsWindowsVersionChk(%d, %d, %d, %s)")
							  _TEXT("//  %s %s %s ,߂l %s\r\n"),
							  Major, Minor, sp, conds,
							  (fMajor == true ? _TEXT("VER_MAJORVERSION") : _TEXT("")),
							  (fMinor == true ? _TEXT("VER_MINORVERSION") : _TEXT("")),
							  (fsp == true ? _TEXT("VER_SERVICEPACKMAJOR") : _TEXT("")),
							  IsWindowsVersionChk(Major, Minor, sp, cond) == TRUE ? _TEXT("TRUE") : _TEXT("FALSE"));
						  GetWindowText(hRet, editBuf, sizeof(editBuf) / sizeof(TCHAR));
						  _tcscat_s(editBuf, sizeof(editBuf) / sizeof(TCHAR), buf);
						  SetWindowText(hRet, editBuf);
						  SendMessage(hRet, WM_VSCROLL, SB_BOTTOM, 0);

						  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("BOOL IsWindowsVersionChk(DWORD Major, DWORD Minor, WORD sp, BYTE cond){\r\n")
							  _TEXT("  OSVERSIONINFOEX os;\r\n")
							  _TEXT("  DWORDLONG	dwlConditionMask = 0;\r\n")
							  _TEXT("  ZeroMemory(&os, sizeof(os));\r\n")
							  _TEXT("  os.dwOSVersionInfoSize = sizeof(os);\r\n"));
						  if (fMajor == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_MAJORVERSION, cond);\r\n"));
						  if (fMinor == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_MINORVERSION, cond);\r\n"));
						  if (fsp == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  dwlConditionMask = VerSetConditionMask(dwlConditionMask, VER_SERVICEPACKMAJOR, cond);\r\n"));

						  if (fMajor == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  os.dwMajorVersion = Major;\r\n"));
						  if (fMinor == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  os.dwMinorVersion = Minor;\r\n"));
						  if (fsp == true)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  os.wServicePackMajor = sp;\r\n"));


						  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT("  return VerifyVersionInfo(&os, "));

						  int n = 0;
						  if (fMajor == true){
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" VER_MAJORVERSION"));
							  ++n;
						  }
						  if (fMinor == true){
							  if (n==1)
								  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" |"));
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" VER_MINORRVERSION"));
							  ++n;
						  }
						  if (fsp == true){
							  if (n >= 1)
								  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" |"));
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" VER_SERVICEPACKMAJOR"));
						  }

						  if (n == 0)
							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR), _TEXT(" 0"));

							  _tcscat_s(buf, sizeof(buf) / sizeof(TCHAR),
							  _TEXT(", dwlConditionMask);\r\n")
							  _TEXT("}\r\n"));

				SendMessage(hSrc, WM_SETTEXT, 0, (LPARAM)buf);


				return TRUE;
			}
			case IDCANCEL:
				EndDialog(hDlg, TRUE);
				return TRUE;
			default:
				return FALSE;
			}
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}
